﻿using System;
using System.IO;
using EnvDTE;
using EnvDTE80;

namespace VsTortoiseSVN.Commands
{
    public class ActiveDocumentAdd : ActiveDocumentBase
    {
        public ActiveDocumentAdd(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
        }

        public override vsCommandStatus QueryStatus()
        {
            if (Application.HasDocument())
            {
                if (SvnHelper.CanAdd(FullName))
                    return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
                else if (SvnHelper.CanAdd(Path.GetDirectoryName(FullName)))
                    return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
            }

            return vsCommandStatus.vsCommandStatusUnsupported;
        }

        public override bool Exec()
        {
            TortoiseProc.Instance.Add(FullName);
            return true;
        }
    }
}
