﻿using System;
using EnvDTE;
using EnvDTE80;

namespace VsTortoiseSVN.Commands
{
    public class ActiveDocumentBlame : ActiveDocumentBase
    {
        public ActiveDocumentBlame(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
            SaveRequired = false;
            PreferredBinding = "Text Editor::Alt+B";
        }

        public override vsCommandStatus QueryStatus()
        {
            if (Application.HasDocument())
            {
                SvnHelperStatusBools statuses = SvnHelperStatusBools.CreateVersioned();
                statuses.Ignored = false;

                if (SvnHelper.HasLocalTextStatus(FullName, statuses))
                    return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
            }

            return vsCommandStatus.vsCommandStatusSupported;
        }

        public override bool Exec()
        {
            if (HasActivePoint())
                TortoiseProc.Instance.Blame(FullName, ActiveLine);
            else
                TortoiseProc.Instance.Blame(FullName);

            return true;
        }
    }
}
