﻿using System;
using EnvDTE;
using EnvDTE80;

namespace VsTortoiseSVN.Commands
{
    public class ActiveDocumentDiff : ActiveDocumentBase
    {
        public ActiveDocumentDiff(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
            PreferredBinding = "Text Editor::Alt+D";
        }

        public override vsCommandStatus QueryStatus()
        {
            if (Application.HasDocument())
            {
                SvnHelperStatusBools statuses = SvnHelperStatusBools.CreateVersioned();
                statuses.Ignored = false;
                statuses.Normal = false;

                if (SvnHelper.HasLocalTextStatus(FullName, statuses))
                    return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
            }

            return vsCommandStatus.vsCommandStatusUnsupported;
        }

        public override bool Exec()
        {
            if (HasActivePoint())
                TortoiseProc.Instance.Diff(FullName, ActiveLine);
            else
                TortoiseProc.Instance.Diff(FullName);

            return true;
        }
    }
}
