﻿using System;
using EnvDTE;
using EnvDTE80;

namespace VsTortoiseSVN.Commands
{
    public class ActiveDocumentEditConflicts : ActiveDocumentBase
    {
        public ActiveDocumentEditConflicts(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
        }

        public override vsCommandStatus QueryStatus()
        {
            if (Application.HasDocument())
            {
                SvnHelperStatusBools statuses = SvnHelperStatusBools.CreateConflicted();

                if (SvnHelper.HasLocalTextStatus(FullName, statuses))
                    return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
            }
            
            return vsCommandStatus.vsCommandStatusUnsupported;
        }

        public override bool Exec()
        {
            TortoiseProc.Instance.EditConflicts(FullName);
            return true;
        }
    }
}
