﻿using System;
using System.Collections.Generic;
using System.IO;
using EnvDTE;
using EnvDTE80;

namespace VsTortoiseSVN.Commands
{

    public class ActiveProjectLog : ActiveProjectBase
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public ActiveProjectLog(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
            SaveRequired = false;
        }

        public override vsCommandStatus QueryStatus()
        {
            if (Application.HasProject())
                return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;

            return vsCommandStatus.vsCommandStatusSupported;
        }

        public override bool Exec()
        {
            string fullName = SvnHelper.GetShowLogPath(GetDirectoryNames());
            TortoiseProc.Instance.ShowLog(fullName);
            return true;
        }
    }
}
