﻿using System;
using System.Collections.Generic;
using EnvDTE;
using EnvDTE80;


namespace VsTortoiseSVN.Commands
{
    public class SolutionExplorerSelectedItemsRepoBrowser : SolutionExplorerSelectedItemsBase
    {
        public SolutionExplorerSelectedItemsRepoBrowser(DTE2 application, string name, string caption, string tooltip, int bitmapId)
            : base(application, name, caption, tooltip, bitmapId)
        {
            SupportFilter = false;
        }

        protected override vsCommandStatus QueryContextSensitiveStatus()
        {
            return QueryStatusImpl();
        }

        protected override vsCommandStatus QueryContextInsensitiveStatus()
        {
            return QueryStatusImpl();
        }

        public override bool Exec()
        {
            List<string> fullNames = GetFullNames();
            TortoiseProc.Instance.RepoBrowser(fullNames[0]);
            return true;
        }

        private vsCommandStatus QueryStatusImpl()
        {
            if (Application.SelectedItems.Count == 1)
                return vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;

            return vsCommandStatus.vsCommandStatusUnsupported;
        }
    }
}
