; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; To add a localization:
; 1) Add the language to the [Languages] section
; 2) Add localizations to the [Messages] section
; 3) Add localizations to the [CustomMessages] section
; 4) Add License Agreement localization
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

[Setup]
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; BEGIN CUSTOMIZATION SECTION: Customize these constants
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#define APP_VERSION                 "32"
#define APP_BETA                    "beta"
#ifndef APP_SVN_VERSION_MAJOR
  #define APP_SVN_VERSION_MAJOR     "1"
#endif
#ifndef APP_SVN_VERSION_MINOR
  #define APP_SVN_VERSION_MINOR     "7"
#endif
#define APP_SVN_VERSION             APP_SVN_VERSION_MAJOR + "." + APP_SVN_VERSION_MINOR
#define APP_SVN_SUFFIX              "svn" + APP_SVN_VERSION_MAJOR + APP_SVN_VERSION_MINOR
#define APP_NAME                    "VsTortoise"
#define APP_ID                      "{{0cbace48-d2e1-42f3-aceb-1c128a3eeebc}"
#define DEFAULT_GROUP_NAME          "{cm:MyAddInDefaultGroupName}"
#define HELP_SHORTCUT               "{cm:MyAddInHelpFile}"
#define DEST_SUB_DIR                "VsTortoise"
#define HELP_FILE_NAME              "VsTortoise.chm"
#define LICENSE_AGREEMENT_FILE_NAME "license.rtf"
#define DLL_FILE_NAME_VS2005        "VsTortoise.dll"
#define DLL_FILE_NAME_VS2008        "VsTortoise.dll"
#define DLL_FILE_NAME_VS2010        "VsTortoise.dll"
#define DLL_FILE_NAME_VS2012        "VsTortoise.dll"
#define DLL_FILE_NAME_VS2013        "VsTortoise.dll"
#define ADDIN_XML_FILE_NAME         "VsTortoise.AddIn"
#define MY_COMPANY_NAME             "Peter Schraut"
#define MY_COMPANY_WEB_SITE 	      "http://vstortoise.codeplex.com"
#define INPUT_FOLDER_NAME 		      "..\Code\bin\" + APP_SVN_SUFFIX
#define OUTPUT_FOLDER_NAME 		      ".\Output"
#define COPYRIGHT_YEAR 			        = "2009-2013"                  


; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; END CUSTOMIZATION SECTION
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
OutputDir={#OUTPUT_FOLDER_NAME}
OutputBaseFilename=vstortoise{#APP_VERSION}{#APP_BETA}_{#APP_SVN_SUFFIX}
AppID={#APP_ID}
VersionInfoVersion={#APP_VERSION}
PrivilegesRequired=admin
MinVersion=0,5.0.2195
AppName={#APP_NAME}
AppVerName={#APP_NAME} build {#APP_VERSION} {#APP_BETA} for SVN {#APP_SVN_VERSION}
DefaultGroupName={#DEFAULT_GROUP_NAME}
AppPublisher={#MY_COMPANY_NAME}
AppPublisherURL={#MY_COMPANY_WEB_SITE}
AppSupportURL={#MY_COMPANY_WEB_SITE}
AppUpdatesURL={#MY_COMPANY_WEB_SITE}
DefaultDirName={pf}\{#DEST_SUB_DIR}
LicenseFile={#LICENSE_AGREEMENT_FILE_NAME}
Compression=lzma
SolidCompression=true
DisableReadyPage=false
ShowLanguageDialog=no
UninstallLogMode=append
;SetupIconFile={#SETUP_ICON_FILE_NAME}
DisableProgramGroupPage=false
VersionInfoCompany={#MY_COMPANY_NAME}
AppCopyright=Copyright  {#COPYRIGHT_YEAR} {#MY_COMPANY_NAME}
AlwaysUsePersonalGroup=false
InternalCompressLevel=ultra
AllowNoIcons=true
LanguageDetectionMethod=locale
WizardImageFile=Images\logo_large.bmp

[Languages]
; USE ENGLISH AS THE FIRST LANGUAGE!!!
Name: English; MessagesFile: compiler:Default.isl

[Types]
Name: Custom; Description: Custom; Flags: iscustom

[Files]
Source: ..\Code\changelog.txt; DestDir: {app}; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\{#DLL_FILE_NAME_VS2005}; DestDir: {app}; Flags: ignoreversion; AfterInstall: CreateAddInXMLFileVS2005(); Check: IsMyAddInVS2005Selected()
Source: {#INPUT_FOLDER_NAME}\{#DLL_FILE_NAME_VS2008}; DestDir: {app}; Flags: ignoreversion; AfterInstall: CreateAddInXMLFileVS2008(); Check: IsMyAddInVS2008Selected()
Source: {#INPUT_FOLDER_NAME}\{#DLL_FILE_NAME_VS2010}; DestDir: {app}; Flags: ignoreversion; AfterInstall: CreateAddInXMLFileVS2010(); Check: IsMyAddInVS2010Selected()
Source: {#INPUT_FOLDER_NAME}\{#DLL_FILE_NAME_VS2012}; DestDir: {app}; Flags: ignoreversion; AfterInstall: CreateAddInXMLFileVS2012(); Check: IsMyAddInVS2012Selected()
Source: {#INPUT_FOLDER_NAME}\{#DLL_FILE_NAME_VS2013}; DestDir: {app}; Flags: ignoreversion; AfterInstall: CreateAddInXMLFileVS2013(); Check: IsMyAddInVS2013Selected()
Source: {#INPUT_FOLDER_NAME}\SharpPlink-Win32.svnExe; DestDir: {app}; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\SharpSvn.dll; DestDir: {app}; Flags: ignoreversion
#if "1.6" == APP_SVN_VERSION || "1.7" == APP_SVN_VERSION
Source: {#INPUT_FOLDER_NAME}\SharpSvn-DB44-20-Win32.dll; DestDir: {app}; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\SharpSvn-SASL21-23-Win32.dll; DestDir: {app}; Flags: ignoreversion
#endif
#if "1.8" == APP_SVN_VERSION
Source: {#INPUT_FOLDER_NAME}\SharpSvn-DB44-20-win32.svnDll; DestDir: {app}; Flags: ignoreversion
#endif
Source: {#INPUT_FOLDER_NAME}\en-US\VsTortoise.resources.dll; DestDir: {app}\en-US; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\af\VsTortoise.resources.dll; DestDir: {app}\af; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\ar\VsTortoise.resources.dll; DestDir: {app}\ar; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\be\VsTortoise.resources.dll; DestDir: {app}\be; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\nl\VsTortoise.resources.dll; DestDir: {app}\nl; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\en\VsTortoise.resources.dll; DestDir: {app}\en; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\de\VsTortoise.resources.dll; DestDir: {app}\de; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\fr\VsTortoise.resources.dll; DestDir: {app}\fr; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\ja\VsTortoise.resources.dll; DestDir: {app}\ja; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\kn\VsTortoise.resources.dll; DestDir: {app}\kn; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\ru\VsTortoise.resources.dll; DestDir: {app}\ru; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\es\VsTortoise.resources.dll; DestDir: {app}\es; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\tr\VsTortoise.resources.dll; DestDir: {app}\tr; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\uk\VsTortoise.resources.dll; DestDir: {app}\uk; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\pl\VsTortoise.resources.dll; DestDir: {app}\pl; Flags: ignoreversion
Source: {#INPUT_FOLDER_NAME}\zh\VsTortoise.resources.dll; DestDir: {app}\zh; Flags: ignoreversion


[Run]
Filename: http://vstortoise.codeplex.com/wikipage?title=Changelog; Description: View Changelog (http://vstortoise.codeplex.com/wikipage?title=Changelog); Flags: postinstall shellexec skipifsilent

[UninstallDelete]
Name: {localappdata}\{#APP_NAME}\settings.xml; Type: files
Name: {localappdata}\{#APP_NAME}\; Type: dirifempty; Languages: 

[Icons]
;Name: {group}\{cm:UninstallProgram,{#APP_NAME}}; Filename: {uninstallexe}
;Name: {group}\{#HELP_SHORTCUT}; Filename: {app}\{#HELP_FILE_NAME}; IconFilename: {app}\{#HELP_FILE_NAME}

[Messages]
English.FinishedLabel=Setup has finished installing [name] on your computer.
English.UninstallStatusLabel=The uninstallation can take up to a minute while the commands of the add-in are removed from the Visual Studio and Macros IDEs.

[CustomMessages]
English.MyAddInWebSite={{#APP_NAME} Web Site
English.VSNeedsToBeClosed=Setup cannot run while Microsoft Visual Studio is running. Please close Microsoft Visual Studio and press OK to continue.
English.RegisteringAddIn=Registering add-in...
English.MyAddInDefaultGroupName={#APP_NAME} for Visual Studio
English.MyAddInHelpFile={#APP_NAME} Help
English.VSRequired=Visual Studio Standard Edition or higher is required to install this product (Express editions of Visual Studio do not support add-ins).
English.TortoiseSVNRequired=Setup was unable to locate TortoiseSVN on your computer.%n%nTortoiseSVN is required for VsTortoise to function properly. You can download it from www.TortoiseSVN.net%n%nDo you want to continue anyway?
English.TortoiseSVNVersionMismatch=Setup found a version mismatch between {#APP_NAME} and TortoiseSVN.%n%nThis VsTortoise version is linked against SVN {#APP_SVN_VERSION}, but TortoiseSVN seems to use a different version. You can download VsTortoise for SVN 1.6, SVN 1.7 and SVN 1.8 at {#MY_COMPANY_WEB_SITE}.%n%nDo you want to continue anyway?

[Code]
var
   IDEsPage: TWizardPage;
   IDEsCheckListBox: TNewCheckListBox;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function GetXMLAddInFullFolderName(Param: String): String;
var
   sCommonAppDataFolder: String;
   sResult: String;
begin
   sCommonAppDataFolder := ExpandConstant('{commonappdata}');

   (* Param is the version such as '8.0' or '9.0' *)
   sResult := sCommonAppDataFolder + '\Microsoft\VisualStudio\' + Param + '\Addins\'

   Result := sResult;
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure CreateAddInXMLFile(sVersion: String; sConnectClassFullName: String; sDLLFileName: String);
var
   sLines: TStrings;
   sXMLAddInFullFileName: String;
   sAddInDLLFullFileName: String;
   sInstallationFolder: String;
   sFolder: String;
begin

   (* Compose the full name of the add-in DLL *)
   sInstallationFolder := ExpandConstant('{app}');
   sAddInDLLFullFileName := sInstallationFolder + '\' + sDLLFileName;

   (* Get the folder where to put the .AddIn XML registration file *)
   sFolder := GetXMLAddInFullFolderName(sVersion);

   (* Ensure that the folder is created *)
   CreateDir(sFolder);

   (* Compose the full name of the .AddIn XML registration file *)
   sXMLAddInFullFileName := sFolder + '{#ADDIN_XML_FILE_NAME}';

   (* Create the .AddIn XML registration file *)
   sLines := TStringList.Create();

   sLines.Add('<?xml version="1.0" encoding="UTF-8" standalone="no"?>');
   sLines.Add('<Extensibility xmlns="http://schemas.microsoft.com/AutomationExtensibility">');
   sLines.Add('   <HostApplication>');
   sLines.Add('      <Name>Microsoft Visual Studio</Name>');
   sLines.Add('      <Version>' + sVersion + '</Version>');
   sLines.Add('   </HostApplication>');
   sLines.Add('   <Addin>');
   sLines.Add('      <FriendlyName>{#APP_NAME}</FriendlyName>');
   sLines.Add('      <Description>{#APP_NAME}</Description>');
   sLines.Add('      <Assembly>' + sAddInDLLFullFileName + '</Assembly>');
   sLines.Add('      <FullClassName>' + sConnectClassFullName + '</FullClassName>');
   sLines.Add('      <LoadBehavior>1</LoadBehavior>');
   sLines.Add('      <CommandPreload>1</CommandPreload>');
   sLines.Add('      <CommandLineSafe>0</CommandLineSafe>');
   sLines.Add('   </Addin>');
   sLines.Add('   <ToolsOptionsPage>');
   sLines.Add('      <Category Name="VsTortoise">');
   sLines.Add('         <SubCategory Name="General">');
   sLines.Add('            <Assembly>' + sAddInDLLFullFileName + '</Assembly>');
   sLines.Add('            <FullClassName>VsTortoiseSVN.OptionPages.GeneralPage</FullClassName>');
   sLines.Add('         </SubCategory>');
(*
   sLines.Add('         <SubCategory Name="Documents">');
   sLines.Add('            <Assembly>' + sAddInDLLFullFileName + '</Assembly>');
   sLines.Add('            <FullClassName>VsTortoiseSVN.OptionPages.DocumentsPage</FullClassName>');
   sLines.Add('         </SubCategory>');
*)

   sLines.Add('         <SubCategory Name="Integration">');
   sLines.Add('            <Assembly>' + sAddInDLLFullFileName + '</Assembly>');
   sLines.Add('            <FullClassName>VsTortoiseSVN.OptionPages.IntegrationPage</FullClassName>');
   sLines.Add('         </SubCategory>');

   sLines.Add('      </Category>');
   sLines.Add('   </ToolsOptionsPage>');
   sLines.Add('</Extensibility>');

   SaveStringToFile(sXMLAddInFullFileName, sLines.Text, False);

end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure CreateAddInXMLFileVS2005();
begin
   CreateAddInXMLFile('8.0','VsTortoise', '{#DLL_FILE_NAME_VS2005}')
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure CreateAddInXMLFileVS2008();
begin
   CreateAddInXMLFile('9.0','VsTortoise', '{#DLL_FILE_NAME_VS2008}')
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure CreateAddInXMLFileVS2010();
begin
   CreateAddInXMLFile('10.0','VsTortoise', '{#DLL_FILE_NAME_VS2010}')
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure CreateAddInXMLFileVS2012();
begin
   CreateAddInXMLFile('11.0','VsTortoise', '{#DLL_FILE_NAME_VS2012}')
end;

procedure CreateAddInXMLFileVS2013();
begin
   CreateAddInXMLFile('12.0','VsTortoise', '{#DLL_FILE_NAME_VS2013}')
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsVSInstalledByProgID(ProgID: String):Boolean;
begin

   if RegKeyExists(HKCR, ProgID) then
      Result := True
   else
      Result := False

end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsVSRunningByProgID(ProgID: String):Boolean;
var
   IDE: Variant;
begin

   try
      IDE := GetActiveOleObject(ProgID);
   except
   end;

   if VarIsEmpty(IDE) then
      Result := False
   else
      Result := True
end;

(***************************************************************************************************)
(* Gets the path of TortoiseProc.exe or an empty string is it is missing                           *)
(***************************************************************************************************)
function GetTortoiseSVNPath():string;
var
  ProcPath: string;
begin
   Result := '';

   if RegQueryStringValue(HKLM32, 'Software\TortoiseSVN', 'ProcPath', ProcPath) then
   begin
     if FileExists(ProcPath) then
       Result := ProcPath;
   end;

   if (Result = '') and IsWin64 then
   begin
     // TortoiseSVN path not found yet and we're on a 64-bit Windows, so check 64bit registry branch
     if RegQueryStringValue(HKLM64, 'Software\TortoiseSVN', 'ProcPath', ProcPath) then
     begin
       if FileExists(ProcPath) then
         Result := ProcPath;
     end;
   end;
end;

(***************************************************************************************************)
(* Checks if TortoiseSVN is installed, by first reading the TortoiseProc path from the registry    *)
(* and then checking if that file exists on the file system                                        *)
(***************************************************************************************************)
function IsTortoiseSVNInstalled():Boolean;
var
  ProcPath: string;
begin
   Result := False;

   ProcPath := GetTortoiseSVNPath();
   if ProcPath <> '' then
   begin
     Result := FileExists(ProcPath);
   end;
end;

(***************************************************************************************************)
(* Gets whether TortoiseSVN 1.8 is installed on the computer                                       *)
(***************************************************************************************************)
function IsTortoiseSVN18():Boolean;
var
  ProcPath: string;
  VersionString: string;
begin
   Result := False;

   ProcPath := GetTortoiseSVNPath();
   if ProcPath <> '' then
   begin
     if GetVersionNumbersString(ProcPath, VersionString) then
     begin
       if (Pos('1.8.', VersionString) = 1) then
         Result := True;
     end;
   end;
end;

(***************************************************************************************************)
(* Gets whether TortoiseSVN 1.7 is installed on the computer                                       *)
(***************************************************************************************************)
function IsTortoiseSVN17():Boolean;
var
  ProcPath: string;
  VersionString: string;
begin
   Result := False;

   ProcPath := GetTortoiseSVNPath();
   if ProcPath <> '' then
   begin
     if GetVersionNumbersString(ProcPath, VersionString) then
     begin
       // TortoiseSVN 1.7 beta = '1.6.99'
       if (Pos('1.6.99', VersionString) = 1) or (Pos('1.7.', VersionString) = 1) then
         Result := True;
     end;
   end;
end;

(***************************************************************************************************)
(* Gets whether VsTortoise and TortoiseSVN versions match and the add-in is likely to work         *)
(***************************************************************************************************)
function IsTortoiseSVNVersionMatch():Boolean;
begin
   Result := True;

   // If VsTortoise uses SVN 1.8, make sure the installed TortoiseSVN version is also 1.8
   if ({#APP_SVN_VERSION} = 1.8) then
     Result := IsTortoiseSVN18();

   // If VsTortoise uses SVN 1.7, make sure the installed TortoiseSVN version is also 1.7
   if ({#APP_SVN_VERSION} = 1.7) then
     Result := IsTortoiseSVN17();

   // If VsTortoise uses SVN 1.6, make sure the installed TortoiseSVN version is not 1.7
   if ({#APP_SVN_VERSION} = 1.6) then
     Result := not IsTortoiseSVN17() and not IsTortoiseSVN18();
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)

function IsVS2005Installed():Boolean;
begin
   if IsVSInstalledByProgID('VisualStudio.DTE.8.0') then
      Result := True
   else
      Result := False
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsVS2008Installed():Boolean;
begin
   if IsVSInstalledByProgID('VisualStudio.DTE.9.0') then
      Result := True
   else
      Result := False
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsVS2010Installed():Boolean;
begin
   if IsVSInstalledByProgID('VisualStudio.DTE.10.0') then
      Result := True
   else
      Result := False
end;

function IsVS2012Installed():Boolean;
begin
   if IsVSInstalledByProgID('VisualStudio.DTE.11.0') then
      Result := True
   else
      Result := False
end;

function IsVS2013Installed():Boolean;
begin
   if IsVSInstalledByProgID('VisualStudio.DTE.12.0') then
      Result := True
   else
      Result := False
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
procedure UnregisterAddInIfInstalled(sVersion: String; sConnectClassFullName: String);
var
   sXMLAddInFullFileName: String;
   sFolder: String;
   sIDEFullFileName: String;
   iResultCode: Integer;
begin

   (* Compose the full name of the .AddIn XML registration file *)
   sFolder := GetXMLAddInFullFolderName(sVersion);
   sXMLAddInFullFileName := sFolder + '{#ADDIN_XML_FILE_NAME}';

   if FileExists(sXMLAddInFullFileName) then
      begin
         (* Delete the .AddIn XML registration file to unregister the add-in *)
         DeleteFile(sXMLAddInFullFileName);

         (* Compose the full name of the Visual Studio IDE *)
         sIDEFullFileName := ExpandConstant('{reg:HKLM\SOFTWARE\Microsoft\VisualStudio\' + sVersion + ',InstallDir}') + 'devenv.exe'

         (* Remove the commands of the IDE *)
         Exec(sIDEFullFileName, '/ResetAddin ' + sConnectClassFullName + ' /command File.Exit', '', SW_HIDE, ewWaitUntilTerminated, iResultCode);

      end

end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsMyAddInVS2005Selected():Boolean;
begin
   Result := (WizardSilent and IsVS2005Installed()) or IDEsCheckListBox.Checked[0]
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsMyAddInVS2008Selected():Boolean;
begin
   Result := (WizardSilent and IsVS2008Installed()) or IDEsCheckListBox.Checked[1]
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
function IsMyAddInVS2010Selected():Boolean;
begin
   Result := (WizardSilent and IsVS2010Installed()) or IDEsCheckListBox.Checked[2]
end;

function IsMyAddInVS2012Selected():Boolean;
begin
   Result := (WizardSilent and IsVS2012Installed()) or IDEsCheckListBox.Checked[3]
end;

function IsMyAddInVS2013Selected():Boolean;
begin
   Result := (WizardSilent and IsVS2013Installed()) or IDEsCheckListBox.Checked[4]
end;

(***************************************************************************************************)
(* Auxiliar function                                                                               *)
(***************************************************************************************************)
type
  LUID = record
      LowPart   : DWord;
      HighPart  : DWord;
  end;
  LUID_AND_ATTRIBUTES = record
    Luid        : LUID;
    Attributes  : DWord;
  end;
  TOKEN_PRIVILEGES = record
    PrivilegeCount : DWord;
    Privileges     : LUID_AND_ATTRIBUTES;
  end;
  PROCESSENTRY32 = record
    dwSize              : DWord;
    cntUsage            : DWord;
    th32ProcessID       : DWord;
    th32DefaultHeapID   : DWord;
    th32ModuleID        : DWord;
    cntThreads          : DWord;
    th32ParentProcessID : DWord;
    pcPriClassBase      : DWord;
    dwFlags             : DWord;
    szExeFile           : Array [0..259] of WideChar;
  end;

const
  INVALID_HANDLE_VALUE = 4294967295;

function LookupPrivilegeValueW(SystemName : Cardinal; Name : String; var Luid : LUID) : DWord;
external 'LookupPrivilegeValueW@advapi32.dll stdcall';
function GetCurrentProcess : DWord;
external 'GetCurrentProcess@kernel32.dll stdcall';
function OpenProcessToken(ProcessHandle : DWord; DesiredAccess : DWord; var TokenHandle : DWord) : DWord;
external 'OpenProcessToken@advapi32.dll stdcall';
function CloseHandle(hObject : DWord) : DWord;
external 'CloseHandle@kernel32.dll stdcall';
function AdjustTokenPrivileges(TokenHandle : DWord; DisableAllPrivileges : DWord; var NewState : TOKEN_PRIVILEGES; BufferLength : DWord; PreviousState : DWord; ReturnLength : DWord) : DWORD;
external 'AdjustTokenPrivileges@advapi32.dll stdcall';
function CreateToolhelp32Snapshot(Flags : DWord; ProcessID : DWord) : DWord;
external 'CreateToolhelp32Snapshot@kernel32.dll stdcall';
function Process32FirstW(hSnapshot : DWord; var lppe : PROCESSENTRY32) : DWORD;
external 'Process32FirstW@kernel32.dll stdcall';
function Process32Next(hSnapshot : DWord; var lppe : PROCESSENTRY32) : DWord;
external 'Process32Next@kernel32.dll stdcall';
function OpenProcess(dwDesiredAccess : DWord; bInheritHandle : DWord; dwProcessId : DWord) : DWord;
external 'OpenProcess@kernel32.dll stdcall';
function GetModuleFileNameExW(hProcess : DWord; hModule : DWord; filename : String; nSize : DWord) : DWord;
external 'GetModuleFileNameExW@psapi.dll stdcall';

function AcquireDebugPrivilege() : Boolean;
var
  TokenPrivileges : TOKEN_PRIVILEGES;
  TokenHandle     : Cardinal;
begin
  Result := False;
  TokenPrivileges.PrivilegeCount        := 1;
  TokenPrivileges.Privileges.Attributes := 2; (* SE_PRIVILEGE_ENABLED *)
  if LookupPrivilegeValueW(0, 'SeDebugPrivilege', TokenPrivileges.Privileges.Luid) <> 0 then
    if OpenProcessToken(GetCurrentProcess, 32 (* TOKEN_ADJUST_PRIVILEGES *), TokenHandle) <> 0 then
    begin
      if AdjustTokenPrivileges(TokenHandle, 0, TokenPrivileges, 0, 0, 0) <> 0 then
        Result := True;
      CloseHandle(TokenHandle);
    end
end;

function IsExecutableRunning(FileName : String) : Boolean;
var
  ProcessSnapshot     : DWord;
  ProcessEntry        : PROCESSENTRY32;
  Process             : DWord;
  ProcessFileName     : String;
  Length              : DWord;
begin
  Result := False;

  // Aquire the debug privilege. We might need this to be able to enumerate all processes.
  AcquireDebugPrivilege

  // Take snapshot of all running processes.
  ProcessSnapshot := CreateToolhelp32Snapshot(2 (* TH32CS_SNAPPROCESS *), 0);
  if ProcessSnapshot = INVALID_HANDLE_VALUE then Exit;

  // Loop over all processes and see if the process in question is amoung them.
  ProcessEntry.dwSize := SizeOf(ProcessEntry);
  if Process32FirstW(ProcessSnapshot, ProcessEntry) <> 0 then
  repeat
    Process := OpenProcess(1040 (* PROCESS_QUERY_INFORMATION or PROCESS_VM_READ *), 0, ProcessEntry.th32ProcessID);
    if Process = 0 then continue;

    SetLength(ProcessFileName, 1024);
    Length := GetModuleFileNameExW(Process, 0, ProcessFileName, 1024);
    CloseHandle(Process);
    if Length = 0 then continue;

    SetLength(ProcessFileName, Length);
    if CompareText(FileName, ExtractFileName(ProcessFileName)) = 0 then
    begin
      Result := True;
      CloseHandle(ProcessSnapshot);
      Exit;
    end;
  until Process32Next(ProcessSnapshot, ProcessEntry) = 0;
  CloseHandle(ProcessSnapshot);
end;

(***************************************************************************************************)
(* InnoSetup event function                                                                        *)
(***************************************************************************************************)
function InitializeSetup(): Boolean;
begin
  Result := False;

  // Make sure that a supported version of Visual Studio ist installed.
  if not (IsVS2005Installed() or IsVS2008Installed() or IsVS2010Installed() or IsVS2012Installed() or IsVS2013Installed()) then
  begin
    MsgBox(CustomMessage('VSRequired'), mbCriticalError, MB_OK);
    Exit;
  end;

  // Make sure TortoiseSVN is installed
  if not IsTortoiseSVNInstalled() then
  begin
    if MsgBox(CustomMessage('TortoiseSVNRequired'), mbError, MB_YESNO) = IDNO then
      Exit;
  end;

  // Make sure VsTortoise and TortoiseSVN use the same SVN version
  if not IsTortoiseSVNVersionMatch() then
  begin
    if MsgBox(CustomMessage('TortoiseSVNVersionMismatch'), mbError, MB_YESNO) = IDNO then
      Exit;
  end;

  // Make sure that Visual Studio is not running.
  while IsExecutableRunning('devenv.exe') do
    if MsgBox(CustomMessage('VSNeedsToBeClosed'), mbInformation, MB_OKCANCEL) = IDCANCEL then Exit;

  Result := True;
end;

procedure OnIDECheckListBoxClicked(Sender: TObject);
begin
  WizardForm.NextButton.Enabled :=IsMyAddInVS2005Selected() or IsMyAddInVS2008Selected() or IsMyAddInVS2010Selected() or IsMyAddInVS2012Selected() or IsMyAddInVS2013Selected();
end;

(***************************************************************************************************)
(* InnoSetup event function                                                                        *)
(***************************************************************************************************)
procedure InitializeWizard();
var
   IDEsLabel: TLabel;
   bIsVS2005Installed: Boolean;
   bIsVS2008Installed: Boolean;
   bIsVS2010Installed: Boolean;
   bIsVS2012Installed: Boolean;
   bIsVS2013Installed: Boolean;
begin
   IDEsPage := CreateCustomPage(wpSelectComponents, SetupMessage(msgWizardSelectComponents), SetupMessage(msgSelectComponentsDesc));

   IDEsLabel := TLabel.Create(IDEsPage);
   IDEsLabel.Caption := SetupMessage(msgSelectComponentsLabel2);
   IDEsLabel.Width := IDEsPage.SurfaceWidth;
   IDEsLabel.Height := ScaleY(40);
   IDEsLabel.AutoSize := False;
   IDEsLabel.WordWrap := True;
   IDEsLabel.Parent := IDEsPage.Surface;

   IDEsCheckListBox := TNewCheckListBox.Create(IDEsPage);
   IDEsCheckListBox.Top := IDEsLabel.Top + IDEsLabel.Height + ScaleY(8);
   IDEsCheckListBox.Width := IDEsPage.SurfaceWidth;
   IDEsCheckListBox.Height := ScaleX(100);
   IDEsCheckListBox.Flat := True;
   IDEsCheckListBox.Parent := IDEsPage.Surface;
   IDEsCheckListBox.OnClickCheck := @OnIDECheckListBoxClicked;

   bIsVS2005Installed := IsVS2005Installed();
   bIsVS2008Installed := IsVS2008Installed();
   bIsVS2010Installed := IsVS2010Installed();
   bIsVS2012Installed := IsVS2012Installed();
   bIsVS2013Installed := IsVS2013Installed();

   IDEsCheckListBox.AddCheckBox('{#APP_NAME} - Visual Studio 2005', '', 0, False, bIsVS2005Installed, False, True, nil)
   IDEsCheckListBox.AddCheckBox('{#APP_NAME} - Visual Studio 2008', '', 0, False, bIsVS2008Installed, False, True, nil)
   IDEsCheckListBox.AddCheckBox('{#APP_NAME} - Visual Studio 2010', '', 0, False, bIsVS2010Installed, False, True, nil)
   IDEsCheckListBox.AddCheckBox('{#APP_NAME} - Visual Studio 2012', '', 0, False, bIsVS2012Installed, False, True, nil)
   IDEsCheckListBox.AddCheckBox('{#APP_NAME} - Visual Studio 2013', '', 0, False, bIsVS2013Installed, False, True, nil)
end;

(***************************************************************************************************)
(* InnoSetup event function                                                                        *)
(***************************************************************************************************)
procedure CurPageChanged(CurPageID: Integer);
begin
  if CurPageID = IDEsPage.ID then
  begin
    // Disable the 'Next' Button when we enter the 'Select Components' page.
    // Always enable during silent installations, otherwise disable it and the user
    // has to pick the visual studio component before he can proceed.
	  WizardForm.NextButton.Enabled := WizardSilent;
  end;
end;

(***************************************************************************************************)
(* InnoSetup event function                                                                        *)
(***************************************************************************************************)
function InitializeUninstall(): Boolean;
begin
  Result := False;

  // Make sure that Visual Studio is not running.
  while IsExecutableRunning('devenv.exe') do
    if MsgBox(CustomMessage('VSNeedsToBeClosed'), mbInformation, MB_OKCANCEL) = IDCANCEL then Exit;

  Result := True;
end;

(***************************************************************************************************)
(* InnoSetup event function                                                                        *)
(***************************************************************************************************)
procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
   if CurUninstallStep = usUninstall then
      begin
         UnregisterAddInIfInstalled('8.0', 'VsTortoise' );
         UnregisterAddInIfInstalled('9.0', 'VsTortoise' );
         UnregisterAddInIfInstalled('10.0', 'VsTortoise' );
         UnregisterAddInIfInstalled('11.0', 'VsTortoise' );
         UnregisterAddInIfInstalled('12.0', 'VsTortoise' );
      end;
end;

